redflix/movies/urls.py
from django.urls import path

from . import views

app_name = 'movies'
urlpatterns = [
    path('', views.index, name='home'),
    path('films', views.listing, name='listing'),
    path('films/edit/<int:pk>', views.edit, name='edit'),
    path('films/add', views.add, name='add'),
    path('films/delete/<int:pk>', views.delete, name='delete'),
]

redflix/redflix/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('movies.urls')),
    path('', include('users.urls'))
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

redflix/users/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views

from . import views

app_name = 'users'
urlpatterns = [
    path('login/', auth_views.LoginView.as_view(template_name='users/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(), name='logout'),
    path('signup/', views.signup, name='signup')
]

redflix/movies/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator 

class Director(models.Model):
  """
  Class Director
  """
  name = models.CharField(max_length=100)
  firstname = models.CharField(max_length=100)

  def __str__(self):
    return self.name + " " + self.firstname

class Actor(models.Model):
  name = models.CharField(max_length=100)
  firstname = models.CharField(max_length=100)

  def __str__(self):
    return self.name + " " + self.firstname

class Genre(models.Model):
  """
  Class Genre
  """
  name = models.CharField(max_length=200)

  def __str__(self):
    return self.name

class Movie(models.Model):
  """
  Class Movie
  """
  title = models.CharField(max_length=200)
  poster = models.ImageField(upload_to='images/', blank=True)
  poster_url = models.URLField(max_length=500, blank=True)
  trailer = models.URLField(max_length=500)
  nationality = models.CharField(max_length=3)
  release = models.IntegerField(default=2000)
  summary = models.TextField()
  note = models.IntegerField(default=5, validators=[MinValueValidator(1), MaxValueValidator(5)])
  pub_date = models.DateTimeField('Date de publication', auto_now=True)
  director = models.ForeignKey(Director, on_delete=models.CASCADE)

  def __str__(self):
    return self.title

class ActorMovie(models.Model):
      actor = models.ForeignKey(Actor, on_delete=models.CASCADE)
      movie = models.ForeignKey(Movie, on_delete=models.CASCADE)

class GenreMovie(models.Model):
      genre = models.ForeignKey(Genre, on_delete=models.CASCADE)
      movie = models.ForeignKey(Movie, on_delete=models.CASCADE)

redflix/users/models.py
from django.db import models

# Create your models here.

redflix/movies/forms.py
from django import forms
from .models import Movie

class MovieForm(forms.ModelForm):
    class Meta:
        model = Movie
        fields = "__all__"

redflix/movies/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.contrib.auth.decorators import login_required

from .models import *
from .forms import *

def index(request):
  latest_movie_list = Movie.objects.order_by('-pub_date')[:4]

  return render(request, 'movies/pages/index.html', {'latest_movie_list': latest_movie_list})

def listing(request):
  movie_list = Movie.objects.order_by('-pub_date')
  actor_list = ActorMovie.objects.all()
  genre_list = GenreMovie.objects.all()

  return render(request, 'movies/pages/listing.html', {'movie_list': movie_list, 'actor_list': actor_list, 'genre_list': genre_list})

# def check_group():
#     return request.user.has_perm('app_name.can_add_cost_price')

# @user_passes_test(check_group)
@login_required
def add(request):
    if request.method == 'POST':
        form = MovieForm(request.POST)

        if form.is_valid():
            form.save()
            return redirect('/films')
    form = MovieForm()

    return render(request, 'movies/pages/add.html', {'form': form})

# @user_passes_test(check_group)
@login_required
def edit(request, pk):
    movie = get_object_or_404(Movie, pk=pk)
    form = MovieForm(request.POST or None, instance=movie)
    if form.is_valid():
        form.save()
        return redirect('/films')
    return render(request, 'movies/pages/edit.html', {'form': form})

# @user_passes_test(check_group)
@login_required
def delete(request, pk):
    movie = get_object_or_404(Movie, pk=pk)
    if request.method == 'POST':
        movie.delete()
        return redirect('/films')
    return render(request, 'movies/pages/delete.html', {'object': movie})

redflix/users/views.py
from django.shortcuts import render, redirect

from django.contrib.auth.forms import UserCreationForm, UserChangeForm

def signup(request) :
    if request.method == 'POST':
        form = UserCreationForm(request.POST)

        if form.is_valid():
            form.save()
            return redirect('/login')
    form = UserCreationForm

    return render(request, 'users/signup.html', {'form': form})

redflix/movies/templates/movies/pages/add.html
{% extends "base.html" %}

{% block title %}Ajouter un film{% endblock %}

{% block content %}
  <h1>Ajouter un film</h1>

  {{ form.non_field_errors }}
  
  <form method="POST">
    {% csrf_token %}
    {{ form.as_p}}
    <button type="submit">Ajouter le film</button>
  </form>

{% endblock %}

redflix/movies/templates/movies/pages/delete.html
{% extends "base.html" %}

{% block title %}Supprimer un film{% endblock %}

{% block content %}
  <h1>Suppression d'un film</h1>
  
  {{ form.non_field_errors }}

  <form method="POST">
    {% csrf_token %}
    Etes-vous sur de supprimer le film ?
    <button type="submit">Oui</button>
  </form>
{% endblock %}

redflix/movies/templates/movies/pages/edit.html
{% extends "base.html" %}

{% block title %}Editer un film{% endblock %}

{% block content %}
  <h1>Editer un film</h1>

  {{ form.non_field_errors }}

  <form method="POST">
    {% csrf_token %}
    {{ form.as_p}}
    <button type="submit">Editer le film</button>
  </form>
  
{% endblock %}

redflix/movies/templates/movies/pages/index.html
{% extends "base.html" %}

{% block title %}Accueil{% endblock %}

{% block style %}
{% load static %}
<link rel="stylesheet" type="text/css" href="{% static 'movies/dist/css/main.css' %}">
{% endblock %}

{% block content %}
  <h1>Films récents :</h1>
  {% if latest_movie_list %}
    <div class="movies_list">
      {% for movie in latest_movie_list %}
        {% if movie.poster %}
          <img src="{{ movie.poster.url }}" alt="Affiche de {{ movie.title }}">
        {% else %}
          <img src="{{ movie.poster_url }}" alt="Affiche de {{ movie.title }}">
        {% endif %}
      {% endfor %}
    </div>
  {% else %}
    <p>Il n'y a pas de films pour le moment !</p>
  {% endif %}
{% endblock %}

redflix/movies/templates/movies/pages/listing.html
{% extends "base.html" %}
{% block style %}
{% load static %}
<link rel="stylesheet" type="text/css" href="{% static 'movies/dist/css/main.css' %}">
{% endblock %}

{% block title %}Liste des films{% endblock %}

{% block content %}
  <h1>Liste de tous les films :</h1>
  {% if movie_list %}
    <div class="movies">
      {% for movie in movie_list %}
      <div class="card">
        {% if movie.poster %}
        <img class="card-img" src="{{ movie.poster.url }}" alt="{{ movie.title }}">
        {% else %}
        <img class="card-img" src="{{ movie.poster_url }}" alt="{{ movie.title }}">
        {% endif %}
        <div class="card-meta">
          <div class="card-body">
            <div class="card-title">{{ movie.title }}</div>
            <p class="card-text excerpt-text">
              {{ movie.summary }}
            </p>
          </div>
          <div class="card-actor">
            <h2>Les acteurs :</h2>
            {% for actor in actor_list %}
              {% if actor.movie == movie %}
                <span class="card-badge">{{ actor.actor }}</span>
              {% endif %}
            {% endfor %}
          </div>
          <div class="card-genre">
            <h2>Genres :</h2>
            {% for genre in genre_list %}
              {% if genre.movie == movie %}
                <span class="card-badge">{{ genre.genre }}</span>
              {% endif %}
            {% endfor %}
          </div>
          {% if perms.movies %}
          <div class="card-buttons">
            <a href="{% url 'movies:edit' movie.id %}">Modifier le film</a>
            <a href="{% url 'movies:delete' movie.id %}">Supprimer le film</a>
          </div>
          {% endif %}
        </div>
      </div>
      {% endfor %}
    </div>
  {% else %}
    <p>Il n'y a pas de films pour le moment !</p>
  {% endif %}
{% endblock %}

redflix/users/templates/users/login.html
{% extends "base.html" %}

{% block style %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'users/dist/css/main.css' %}">
{% endblock %}

{% block title %}Connexion{% endblock %}

{% block content %}
  {% if form.errors %}
  <div class="alert" role="alert">
    <div class="alert-body">
      <div class="icon"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M2.93 17.07A10 10 0 1 1 17.07 2.93 10 10 0 0 1 2.93 17.07zm12.73-1.41A8 8 0 1 0 4.34 4.34a8 8 0 0 0 11.32 11.32zM9 11V9h2v6H9v-4zm0-6h2v2H9V5z"/></svg></div>
      <div>
        <p class="alert-title">Saisissez un nom d'utilisateur et un mot de passe valides.</p>
        <p class="alert-text">Remarquez que chacun de ces champs est sensible à la casse (différenciation des majuscules/minuscules).</p>
      </div>
    </div>
  </div>
  {% endif %}
  <div class="card-form">
    <form method="post" action="{% url 'users:login' %}">
      {% csrf_token %}
      <div>
        {{ form.username.label_tag }}
        {{ form.username }}
      </div>
      <div>
        {{ form.password.label_tag }}
        {{ form.password }}
      </div>

      <button type="submit">Se connecter</button>
      <input type="hidden" name="next" value="{{ next }}">

    </form>
  </div>
{% endblock %}

redflix/users/templates/users/signup.html
{% extends "base.html" %}

{% block style %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'users/dist/css/main.css' %}">
{% endblock %}

{% block title %}Connexion{% endblock %}

{% block content %}
  {% if form.errors %}
  <div class="alert" role="alert">
    <div class="alert-body">
      <div class="icon"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M2.93 17.07A10 10 0 1 1 17.07 2.93 10 10 0 0 1 2.93 17.07zm12.73-1.41A8 8 0 1 0 4.34 4.34a8 8 0 0 0 11.32 11.32zM9 11V9h2v6H9v-4zm0-6h2v2H9V5z"/></svg></div>
      <div>
        <p class="alert-title">Saisissez un nom d'utilisateur et un mot de passe valides.</p>
        <p class="alert-text">Remarquez que chacun de ces champs est sensible à la casse (différenciation des majuscules/minuscules).</p>
      </div>
    </div>
  </div>
  {% endif %}
  <div class="card-form">
    <form method="post" action="{% url 'users:signup' %}">
      {% csrf_token %}
      <div>
        {{ form.username.label_tag }}
        {{ form.username }}
        {{ form.username.errors }}
      </div>
      <div>
        {{ form.password1.label_tag }}
        {{ form.password1 }}
        {{ form.password1.errors }}

      </div>
      <div>
        {{ form.password2.label_tag }}
        {{ form.password2 }}
        {{ form.password2.errors }}
      </div>

      <button type="submit">S'inscrire</button>
      <input type="hidden" name="next" value="{{ next }}">

    </form>
  </div>
{% endblock %}